#include <stdint.h>

#ifdef WIN32
#include <windows.h>
typedef HANDLE serial_device_t;
typedef DWORD speed_t;
#define BAUD(X) X
#else
typedef int serial_device_t;
#include <termios.h>
#define BAUD_(A,B) A##B
#define BAUD(X) BAUD_(B,X)
#endif

serial_device_t serial_opendevice(char *device, speed_t baud);
int serial_getc(serial_device_t fd, int timeout_ms);
int serial_putc(serial_device_t fd, uint8_t c);
void serial_put(serial_device_t fd, void *buf, int len);

#define SERIAL_TIMEOUT -1
#define SERIAL_ERROR -2
